function [k b]=mean2_conditioning(A,B)

I=eye(size(A,1));
Z=sqrtm(B/A);
iZ=inv(Z);

M1=inv(kron(I,iZ)+kron(iZ,I));
M2=inv(kron(I,Z)+kron(Z,I));

defect=max(1/2*norm(A-A')/norm(A),1/2*norm(B-B')/norm(B));
if (defect>1e-15)
  s=sprintf('Warning: lack of Hermitianicity of size %e',defect);
  disp(s);
end
A=(A+A')/2;B=(B+B')/2;


mult=norm([A B],'fro')/norm(mean2_polar(A,B),'fro');
k=norm([M1 M2])*mult;

r=rho(Z);ir=rho(iZ);
b(1)=1/2*max(r,ir);
b(3)=1/2*min(cond(A),cond(B))*sqrt(max(abs(eig(B\A)))+max(abs(eig(A\B))));

[K D]=eig(Z);

b(2)=1/2*cond(kron(K,K))*sqrt(max(abs(eig(Z)))^2+max(abs(eig(iZ)))^2);

b=b*mult;