function [G w]=mean2_minimax(A,B,N)

n=size(A,1);
I=eye(n);

w=eig(A,B);
m=min(w);M=max(w);
k2=m/M;

Kp=ellipke(1-k2);
t=i*(.5:N)*Kp/N;
[sn cn dn]=ellipj(imag(t),1-k2);
cn=1./cn;dn=dn.*cn;sn=i*sn.*cn;
w=sqrt(m)*sn;
dzdt=cn.*dn;

S=zeros(size(A));
for j=1:N
  S=S-inv(A-w(j)^2*B)*dzdt(j);
end
G=B*(-2*Kp*sqrt(m)/(pi*N))*S*A;
