clear;
n=8;ct=0;grafics=2; % grafics=1->plot, graphics=2->bars
of=1;
for expA=4+of:4:12+of
 for expB=expA:4:12+of

  cndA=10^(expA);cndB=10^(expB);
  A=random(n,3,cndA);
  B=random(n,3,cndB);
  vA=vpa(A);
  vB=vpa(B);

  [cond b]=mean2_conditioning(A,B); 
  s=sprintf('Condition number %e\nLower bound %e Upper bounds %e<%e',cond,b(1),b(2),b(3));
  disp(s);

  Gv=sharp_vpa(vA,vB,vpa(1/2));
  G=double(Gv);

  Gp=mean2_polar(A,B);
  err_polar=norm(Gp-double(Gv))/norm(double(Gv)),

  Gs=sharp(A,B,1/2);
  err_sharp=norm(Gs-double(Gv))/norm(double(Gv)),

  Gsg=mean2_sign(A,B);
  err_sign=norm(Gsg-double(Gv))/norm(double(Gv)),

  Gsa=mean2_avera(A,B);
  err_avera=norm(Gsa-double(Gv))/norm(double(Gv)),

  G3s=mean2_ttstab(A,B);
  err_tterm=norm(G3s-double(Gv))/norm(double(Gv)),

  ct=ct+1;
  err_total(1,ct)=cond*eps;
  err_total(2,ct)=err_sharp;
  err_total(3,ct)=err_avera;
  err_total(4,ct)=err_polar;
  err_total(5,ct)=err_tterm;
  err_total(6,ct)=err_sign;
 end
end

if grafics==1
  [w sor]=sort(err_total(1,:));  
  semilogy(1:6,max(err_total(2,sor),1e-17));
  hold on
  semilogy(1:6,max(err_total(3,sor),1e-17),'r');
  semilogy(1:6,max(err_total(4,sor),1e-17),'g');
  semilogy(1:6,max(err_total(5,sor),1e-17),'m');
  semilogy(1:6,max(err_total(6,sor),1e-17),'k');
  axis([0 7 1e-18 1e-2]);
  legend('sharp','avera','polar','tterm','sign');
end

if grafics==2 
  figure(2);
  cmap=colormap(cool(5));
  errt=err_total';
  clf;bar(15+log10(errt(:,2:6)));
  legend('sharp','avera','polar','tterm','sign','Location','NorthWest');
  set(gca,'Xticklabel',{'(1e5,1e5)','(1e5,1e9)','(1e5,1e13)','(1e9,1e9)','(1e9,1e13)','(1e13,1e13)'});
  set(gca,'Yticklabel',{'1e-16','1e-14','1e-12','1e-10','1e-8','1e-6'});
end