function G=sharp(A,B,t)

% [G,ma,mB]=SHARP(A,B,t) computes the point G=g(t) of the geodesic g joining 
%   A and B such that g(0)=A and g(1)=B, i.e., A(A^{-1}B)^t=B(B^{-1}A)^{1-t}
%
%   A,B: positive definite matrices
%   G: the point on the 
%   t: real parameter
%   ma,mb: condition numbers of thematrices A and B, respectively

[Ua Va]=eig(A);
sA=Ua*(Va.^(vpa(1/2)))/Ua;
isA=inv(sA);
[U V]=eig(isA*B*isA);
G=sA*(U*(diag(diag(V).^(t)))/U)*sA;
